﻿using System;
using System.Collections.Generic;

namespace WzorceProjektowe
{
    /*
    sealed class RejestrZdarzeń //singleton
    {
        private RejestrZdarzeń()
        {
        }

        public static RejestrZdarzeń Instancja = new RejestrZdarzeń();

        private List<string> zdarzenia = new List<string>();

        public void DodajZdarzenie(string zdarzenie)
        {
            zdarzenia.Add(DateTime.Now.ToString() + ": " + zdarzenie);
        }

        public void ZapiszZdarzenia(string ścieżkaPliku)
        {
            System.IO.File.WriteAllLines(ścieżkaPliku, zdarzenia);
        }
    }
    */

    /*
    sealed class RejestrZdarzeń //singleton z leniwą(opóźniona) inicją 
    {
        private RejestrZdarzeń()
        {
        }

        private static RejestrZdarzeń instancja = null;

        public static RejestrZdarzeń Instancja
        {
            get
            {
                if (instancja == null) instancja = new RejestrZdarzeń();
                return instancja;
            }
        }

        private List<string> zdarzenia = new List<string>();

        public void DodajZdarzenie(string zdarzenie)
        {
            zdarzenia.Add(DateTime.Now.ToString() + ": " + zdarzenie);
        }

        public void ZapiszZdarzenia(string ścieżkaPliku)
        {
            System.IO.File.WriteAllLines(ścieżkaPliku, zdarzenia);
        }
    }
    */

    /*
    sealed class RejestrZdarzeń //'dublet' z leniwą(opóźniona) inicją
    {
        private RejestrZdarzeń()
        {
        }

        private static bool ostatniaByłaInstanacja2 = true;
        private static RejestrZdarzeń instancja1 = null;
        private static RejestrZdarzeń instancja2 = null;

        public static RejestrZdarzeń Instancja
        {
            get
            {
                if (ostatniaByłaInstanacja2)
                {
                    if (instancja1 == null) instancja1 = new RejestrZdarzeń();
                    ostatniaByłaInstanacja2 = false;
                    return instancja1;
                }
                else
                {
                    if (instancja2 == null) instancja2 = new RejestrZdarzeń();
                    ostatniaByłaInstanacja2 = true;
                    return instancja2;
                }
                
            }
        }
            
        private List<string> zdarzenia = new List<string>();

        public void DodajZdarzenie(string zdarzenie)
        {
            zdarzenia.Add(DateTime.Now.ToString() + ": " + zdarzenie);
        }

        public void ZapiszZdarzenia(string ścieżkaPliku)
        {
            System.IO.File.WriteAllLines(ścieżkaPliku, zdarzenia);
        }

        public static void ZapiszWszystkieZdarzenia()
        {
            instancja1.ZapiszZdarzenia("zdarzenia1.txt");
            instancja2.ZapiszZdarzenia("zdarzenia2.txt");
        }
    }
    */

    static class RejestrZdarzeń //singleton jako klasa statyczna 
    {
        private static List<string> zdarzenia = new List<string>();

        public static void DodajZdarzenie(string zdarzenie)
        {
            zdarzenia.Add(DateTime.Now.ToString() + ": " + zdarzenie);
        }

        public static void ZapiszZdarzenia(string ścieżkaPliku)
        {
            System.IO.File.WriteAllLines(ścieżkaPliku, zdarzenia);
        }
    }
}
